// Code generated by go-swagger; DO NOT EDIT.

package service_instances

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// ServiceInstanceDeprovisionReader is a Reader for the ServiceInstanceDeprovision structure.
type ServiceInstanceDeprovisionReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ServiceInstanceDeprovisionReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewServiceInstanceDeprovisionOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 202:
		result := NewServiceInstanceDeprovisionAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewServiceInstanceDeprovisionBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 410:
		result := NewServiceInstanceDeprovisionGone()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 422:
		result := NewServiceInstanceDeprovisionUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewServiceInstanceDeprovisionOK creates a ServiceInstanceDeprovisionOK with default headers values
func NewServiceInstanceDeprovisionOK() *ServiceInstanceDeprovisionOK {
	return &ServiceInstanceDeprovisionOK{}
}

/*ServiceInstanceDeprovisionOK handles this case with default header values.

OK
*/
type ServiceInstanceDeprovisionOK struct {
	Payload models.Object
}

func (o *ServiceInstanceDeprovisionOK) Error() string {
	return fmt.Sprintf("[DELETE /v2/service_instances/{instance_id}][%d] serviceInstanceDeprovisionOK  %+v", 200, o.Payload)
}

func (o *ServiceInstanceDeprovisionOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewServiceInstanceDeprovisionAccepted creates a ServiceInstanceDeprovisionAccepted with default headers values
func NewServiceInstanceDeprovisionAccepted() *ServiceInstanceDeprovisionAccepted {
	return &ServiceInstanceDeprovisionAccepted{}
}

/*ServiceInstanceDeprovisionAccepted handles this case with default header values.

Accepted
*/
type ServiceInstanceDeprovisionAccepted struct {
	Payload *models.AsyncOperation
}

func (o *ServiceInstanceDeprovisionAccepted) Error() string {
	return fmt.Sprintf("[DELETE /v2/service_instances/{instance_id}][%d] serviceInstanceDeprovisionAccepted  %+v", 202, o.Payload)
}

func (o *ServiceInstanceDeprovisionAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.AsyncOperation)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewServiceInstanceDeprovisionBadRequest creates a ServiceInstanceDeprovisionBadRequest with default headers values
func NewServiceInstanceDeprovisionBadRequest() *ServiceInstanceDeprovisionBadRequest {
	return &ServiceInstanceDeprovisionBadRequest{}
}

/*ServiceInstanceDeprovisionBadRequest handles this case with default header values.

Bad Request
*/
type ServiceInstanceDeprovisionBadRequest struct {
	Payload *models.Error
}

func (o *ServiceInstanceDeprovisionBadRequest) Error() string {
	return fmt.Sprintf("[DELETE /v2/service_instances/{instance_id}][%d] serviceInstanceDeprovisionBadRequest  %+v", 400, o.Payload)
}

func (o *ServiceInstanceDeprovisionBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewServiceInstanceDeprovisionGone creates a ServiceInstanceDeprovisionGone with default headers values
func NewServiceInstanceDeprovisionGone() *ServiceInstanceDeprovisionGone {
	return &ServiceInstanceDeprovisionGone{}
}

/*ServiceInstanceDeprovisionGone handles this case with default header values.

Gone
*/
type ServiceInstanceDeprovisionGone struct {
	Payload *models.Error
}

func (o *ServiceInstanceDeprovisionGone) Error() string {
	return fmt.Sprintf("[DELETE /v2/service_instances/{instance_id}][%d] serviceInstanceDeprovisionGone  %+v", 410, o.Payload)
}

func (o *ServiceInstanceDeprovisionGone) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewServiceInstanceDeprovisionUnprocessableEntity creates a ServiceInstanceDeprovisionUnprocessableEntity with default headers values
func NewServiceInstanceDeprovisionUnprocessableEntity() *ServiceInstanceDeprovisionUnprocessableEntity {
	return &ServiceInstanceDeprovisionUnprocessableEntity{}
}

/*ServiceInstanceDeprovisionUnprocessableEntity handles this case with default header values.

Unprocessable Entity
*/
type ServiceInstanceDeprovisionUnprocessableEntity struct {
	Payload *models.Error
}

func (o *ServiceInstanceDeprovisionUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /v2/service_instances/{instance_id}][%d] serviceInstanceDeprovisionUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *ServiceInstanceDeprovisionUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
